#include "String.mqh"

struct FILE_PRICES
{
  int Size;

  string Name;
  string Path;

  FILE_PRICES( void ) : Size(INT_MIN)
  {
  }

  string FullPath( void ) const
  {
    return(this.Path + this.Name);
  }

  int SetSize( void )
  {
    return((this.Size == INT_MIN) ? (this.Size = (int)::FileGetInteger(this.FullPath(), FILE_SIZE)) : this.Size);
  }

  bool operator ==( const FILE_PRICES &File ) const
  {
    return((this.Name == File.Name) && (this.Size == File.Size));
  }

  bool IsBegin( const string &Str ) const
  {
  #ifndef FILE_FILTER
    return(STRING::IsBegin(this.Name, Str));
  #else // FILE_FILTER
    FILE_FILTER

    bool Res = STRING::IsBegin(this.Name, Str);

    if (Res)
    {
      Res = false;

      for (int i = ::ArraySize(Filters) - 1; (i >= 0) && !Res; i--)
        Res |= (::StringFind(this.Name, Filters[i]) != -1);
    }

    return(Res);
  #endif // FILE_FILTER
  }

  string ToString() const
  {
    return(this.FullPath() + " " + (string)this.Size + " bytes");
  }
};